require 'gphys_const'
require "numru/ggraph"
include NumRu
include NMath

#########################################################################################

def calc_msf( gphys )

km    = gphys.shape[2]
lat   = gphys.coord(1).val
level = gphys.coord(2).val
if gphys.coord(2).get_att('units') == 'millibar'
  level = level * 100.0
end
rmiss = gphys.get_att('missing_value')[0]

gphyswithzero           = gphys.copy
mask                    = gphyswithzero.ne(rmiss)
gphyswithzero[mask.not] = 0.0
gphyswithzero           = gphyswithzero.mean('lon')

gphysout = gphyswithzero.copy

gphysout[true,km-1] = gphyswithzero[true,km-1] * level[km-1] / Grav
k = km-1-1
while k >= 0
  gphysout[true,k] = gphysout[true,k+1] + ( gphyswithzero[true,k] + gphyswithzero[true,k+1] ) * 0.5 * ( level[k] - level[k+1] ) / Grav * 2 * PI * RPlanet * cos( lat[true] * PI / 180.0 )
  k -= 1
end

gphysout = gphysout * 1.0e-8

gphysout.long_name          = 'mass stream function'
gphysout.units              = '1e8 kg/s'
gphysout.coord(1).long_name = 'pressure'
gphysout.coord(1).val       = level
gphysout.coord(1).units     = 'Pa'

return gphysout

end

#########################################################################################
